/*
 * uss_release.c
 *
 * Created: 2013/01/15 7:17:42
 *  Author: takuya_saitou
 */ 


#include <avr/io.h>		//avr̕Wo̓wb_[t@C
#include <avr/interrupt.h>	//荞݂邽߂̃wb_[t@C
#define F_CPU 20000000UL	//util/delay.h錾Oɓg錾A炵
#include <util/delay.h>		//delay_ms,delay_usg߂̃wb_[t@C

#define sbi(PORT,BIT) PORT |= _BV(BIT)		//rbg₷邽߂̃}N@
#define cbi(PORT,BIT) PORT &= ~_BV(BIT)

		//̂RsŃ{[[g`Ă
#define FOSC 20000000 // 20MHz	(쓮g)
#define BAUD 9600	//{[[g
#define MYUBRR 129 //FOSC/16/BAUD-1

//ϐ

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;

#define PLS_UP 1
#define PLS_DOWN 0
volatile uchar pls_state;	//volatile͊荞݊֐globalϐ̒l邽߂ɕKv
volatile uchar msr_state;

volatile ushort a=0,b=0;
volatile ulong j=0;
volatile ulong count;

// t[Ȃ̂16bytesbufferOŗpӂ@{256bytepӂAattiny2313̃Ȃ̂łȂƂȂ16
volatile char usart_recvData[16];    // USARTŎMf[^Bring buffer
volatile int  usart_counter;        // ݂writeʒu(usart_recvDataindex)
int  usart_counter2;         // ݂readʒu(usart_recvDataindex)

//֐̒`(֐vg^Cv錾Ă)

/* sioݒ */
void sio_init(unsigned int ubrr)
{
	UBRRH = (unsigned char)(ubrr>>8);    // {[[g8bit
	UBRRL = (unsigned char)ubrr;        // {[[g8bit
	UCSRB = (1<<RXEN) | (1<<RXCIE);    // M,荞݋@@M͑M鎞
	UCSRC = (3<<UCSZ0) ;        // stopbit 1bit , 8bitM
}

// M܂őҋ@
void wait_for_sending()
{
	loop_until_bit_is_set(UCSRA,UDRE); // Mf[^WX^󂫂܂őҋ@
}

// f[^MĂ邩̃`FbNBMĂȂ0B
int is_received()
{
	return  (usart_counter !=  usart_counter2) ? 1 : 0;
	// readʒuwriteʒuقȂȂΎMf[^͂
}

// Mf[^ԂBMf[^Ȃꍇ͎M܂őҋ@B
int getReceivedData()
{
	int i;
	while(!is_received())
	i=0;
	return usart_recvData[usart_counter2++ & 0xff];
}

// 荞݂ɂM
ISR(USART_RX_vect){
	cli();	//荞݋֎~
	usart_recvData[usart_counter++ & 0xff] = UDR;    // Mf[^Mobt@Ɋi[
	sei();	//荞݋
}

//荞݂ɂpX
ISR(TIMER1_CAPT_vect){
	cli();
	if(pls_state==PLS_UP){//オ茟o
		pls_state=PLS_DOWN;
		a=ICR1;	//^C}[̒l
		j=0;
		cbi(TCCR1B,ICES1);@	//CvbgLv`[𗧉ɐݒ
		sbi(TIMSK,TOIE1);	//Timer1̃I[o[t[荞݂
	}else{
		pls_state=PLS_UP;//茟o
		b=ICR1;	//^C}[̒l
		sbi(TCCR1B,ICES1);	//CvbgLv`[𗧂オɐݒ
		j--;
		if(a<b){	//^C}[I[o[t[ĂpXł悤ɂ
			count=b-a+(j<<16);
		}else{
			j--;
			count=(0xffff-a)+b+(j<<16);
		}
		cbi(TIMSK,TOIE1);	//I[o[t[荞݋֎~
		msr_state=0;		//main֐while𔲂
	}
	sei();
}

//TIMER1I[o[t[荞
ISR(TIMER1_OVF_vect){
	cli();
	j++;
	sei();
}

int main(void)//(ICP PD6)
{
	int noivent;
	unsigned int d=0;
	volatile ushort distance;	
	sio_init(MYUBRR);		// SIOݒ
	TCCR1B=0x41;//01000001	//^C}[1̐ݒ@:
	TIMSK=_BV(ICIE1);	//^C}[1荞݋
	pls_state=PLS_UP;
	sei(); // S荞݋

	while(1)
	{
		d = getReceivedData();	//Meۑ
		if(d==0x01){	//Y̎ʔԍʂ@1Ȃ0x01
			count=0;
			msr_state=1;
			sbi(DDRD,6);	//PIND6o͐ݒ
			_delay_us(200);
			cli();		//S荞݋֎~
			sbi(PORTD,6);	//PIND6"1"ɂ	5us̃pXo
			_delay_us(5);
			cbi(PORTD,6);	//PIND6"0"ɂ
			_delay_us(200);
			cbi(DDRD,6);	//PIND6͐ݒ
			sei();		
			_delay_us(500);
			
			while(msr_state==1){	//pX芄荞݂I܂Ń[v
				noivent=0;
			}

			distance=count*0.00081;	//324*100/2/20000000=0.00081@@JEgɊZ
			distance=distance-11;	//Ȃ11cmvXꂽlo悤Ȃ̂ŕҏW
			if (distance>255)	//MIRS1byteŎM悤Ȃ̂255Ńf[^ł؂
			{
				distance=255;
			}
			sbi(UCSRB,TXEN);	//USRATM
			_delay_us(200);
			wait_for_sending();
			UDR = distance;		//M
			d=0;			//ʔԍ(ی)
			_delay_us(200);
			cbi(UCSRB,TXEN);	//USRATM֎~
		}else{
			d=0;
			noivent=0;//Y̎ʔԍłȂ΍ŏɖ߂
		}		
	}

}